SystemOrganization addCategory: #'CS528su13-Tiki'!

TestCase subclass: #TikiNativeFileDatabaseTest
	instanceVariableNames: 'testdb testPage testSum'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiNativeFileDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:24'!
setUp
	testdb := TikiNativeFileDatabase open: 'test_database'.
! !

!TikiNativeFileDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:25'!
testNewTag
	| tmp |
	tmp := (testdb loadRawPageFor: #notThere).
	self assert: tmp = nil! !

!TikiNativeFileDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:00'!
testRawPageAccessing
	| tmp |
	testdb saveRawPage: 'line1' for: #intemediateResult.
	tmp := (testdb loadRawPageFor: #intemediateResult).
	self assert: tmp = 'line1'! !

!TikiNativeFileDatabaseTest methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:24'!
testRawSumAccessing
	| tmp |
	testdb saveRawPage: 'line1' for: #intemediateResult.
	tmp := (testdb loadRawPageFor: #intemediateResult).
	self assert: tmp = 'line1'! !

WAComponent subclass: #TikiCachedWebPage
	instanceVariableNames: 'htmlcontent summary rank tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiCachedWebPage commentStamp: '<historical>' prior: 0!
Instances are created when user's requesting a page and cached in TikiWebPagePool.

The instances have ready to view html content in memory so if there's another request for the page, html content can be sent to user without overhead.

Rank will be used for tag clound.!

!TikiCachedWebPage methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/12/2013 01:15'!
id
	^tag! !

!TikiCachedWebPage methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/12/2013 01:16'!
id: aSymbol 
	tag := aSymbol! !

!TikiCachedWebPage methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/12/2013 01:17'!
renderContentOn: html
	html text: 'You just clicked on:'.
	html heading level3
	 	with: tag asString
	! !

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb commentStamp: '<historical>' prior: 0!
A TikiWeb is container for the web controls.

Instance Variables
!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:38'!
style 
	^'.mainbox{ 
		margin-left:auto;
		margin-right:auto;
		width:60%;
		border:1px;
		background:#EDE;
	}
	.existingtag a:link {color:black; text-decoration:none}
	.existingtag a:visited{color:black; text-decoration:none}
	.existingtag a:hover { color:gray; text-decoration:none} 
	.existingtag a:active { color:black; text-decoration:none}
	
	.editcontrols { 
	border:solid 3px; background:#BBBBBB; 
	}
	.titletext { font-size:18px }
	#summarytext a:link {
		color:#66AA66; text-decoration:none
		}
	.newtag a:link {color:black; text-decoration:none}
	.newtag a:visited{color:black; text-decoration:none}
	.newtag a:hover{color:#FF2222; text-decoration:none}
	.newtag a:active { color:black; text-decoration:none}
	
	.nolink a:link {color:black; text-decoration:none}
	.nolink a:visited{color:black; text-decoration:none}
	.nolink a:hover{color:black; text-decoration:none}
	.nolink a:active { color:black; text-decoration:none}
		'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'allPages mainInput summaryInput currentPage editting makingnewpage expanded currentTag currentTOCPage currentCourse tempCourse allSummaries linkTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain commentStamp: '<historical>' prior: 0!
A TikiWebMain is the main page for objects

Instance Variables
	allPages:		<Object>
	currentCourse:		<Object>
	currentPage:		<Object>
	currentTOCPage:		<Object>
	currentTag:		<Object>
	editting:		<Object>
	expanded:		<Object>
	mainInput:		<Object>
	makingnewpage:		<Object>
	summaryInput:		<Object>

allPages
	- xxxxx

currentCourse
	- xxxxx

currentPage
	- xxxxx

currentTOCPage
	- xxxxx

currentTag
	- xxxxx

editting
	- xxxxx

expanded
	- xxxxx

mainInput
	- xxxxx

makingnewpage
	- xxxxx

summaryInput
	- xxxxx
!

TikiWebMain subclass: #TikiWebControl
	instanceVariableNames: 'pageDB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebControl class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:12'!
canBeRoot
	^true! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:23'!
buildPage: html 
	super renderContentOn: html! !

!TikiWebControl methodsFor: 'renderPopup' stamp: 'PengLiu 7/12/2013 01:19'!
dialogContentFor: aSymbal
	^TikiCachedWebPage new id: aSymbal! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:13'!
initialize
	super initialize.
	editting:=false.
	mainInput:='Test input'.
	pageDB := TikiDataBaseServer getInstance connectToDB: ''.

! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderBackAnchor: html
	html listItem 
		with: 'Back'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/12/2013 01:33'!
renderContentOn: html
	html header
		with: [ self renderSiteBigLogo: html ].
	html navigation
		class: 'topnav';
		with: [ self renderNavMenu: html ].
	html div
		id: 'main';
		class: 'tikipage';
		with: [ super renderContentOn: html].
	html navigation
		class: 'topnav';
		with: [ self renderNavMenu: html ].
	html div
		id: 'popup';
		script: (html jQuery new dialog
     			title: '';
			position: 'right';
	     		autoOpen: false);
     		with: [ self renderDialogOn: html].
! !

!TikiWebControl methodsFor: 'renderPopup' stamp: 'PengLiu 7/12/2013 01:20'!
renderDialogOn: html
	html div class: 'box'; with: [
		html div
			id: #boxcontent;
			class: 'content';
			with: 'Brief explanation, cross references, all forum posts about this, etc' ]! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderForwordAnchor: html
	html listItem with: 'Forward'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:13'!
renderNavMenu: html
	html unorderedList 
		class: 'navigation';
		with: [ self renderBackAnchor: html.
				self renderPrevLessonAnchor: html for: currentPage.
				self renderUpButton: html for: currentPage.
				self renderNextLessonAnchor: html for: currentPage.
				self renderForwordAnchor: html. ].
	html unorderedList 
		class: 'navigation';
		with: [ self renderSummaryButton: html for: currentPage ]! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:12'!
renderNextLessonAnchor: html for: aPage
	html listItem with: 'Next'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:13'!
renderPrevLessonAnchor: html for: aPage
	html listItem with: 'Previous'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:49'!
renderSiteBigLogo: html
	html heading 
		level1
		with: 'Tiki System Official Demo'! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/12/2013 00:42'!
renderSummaryButton: html for: aPage
	html div
		id: 'tiki';
		with: [ 
			html listItem 
				with: [ 
					html anchor
						onClick: ((html jQuery id: 'popup') dialog
								open
								);
						onClick: (html jQuery ajax 
								script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: aPage tag) ]
						);		
						with: 'Summary'
					]
				]
! !

!TikiWebControl methodsFor: 'renderNav' stamp: 'PengLiu 7/11/2013 23:03'!
renderUpButton: html for: aPage
	html listItem with: 'Up'! !

!TikiWebControl methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/12/2013 01:31'!
style
	^ '
	header {
	   	border-bottom: 10px solid #74B46F;
    		margin: 0 auto;
    		text-align: center;
    		width: 100%;
	}
	header {
 	   	font-size: 1.5em;
	}
	header h1 {
    		margin-bottom: 0;
	}
	
	header h3 {
    		margin-bottom: 0.3em;
    		margin-top: 0;
	}
	
	div.box div.content{
		width: 100%;
	}
	div.box div.content{
    		border-color: #ff0000;
    		border-style: solid;
    		padding: 0 1em;
    		width: 12em;
	}
	div#main {
		min-height: 500px;
		margin: 30px auto;
		width: 100%;
    		border-color: #74B46F;
    		border-style: solid;
    		padding: 0 1em;
    		width: 58em;
	}

	div.content {
		margin: 30px auto;
		width: 100%;
	}
	
	div.content {
    		border-color: #74B46F;
    		border-style: solid;
    		padding: 0 1em;
    		width: 42em;
	}

	nav.topnav {
    		font-family: ''PT Sans'',sans-serif;
    		font-size: 1.2em;
    		margin: 15px 0;
    		text-align: center;
    		width: 100%;
	}
	nav.topnav ul.navigation {
    		list-style: none outside none;
    		margin: 0;
 	   	padding: 0;
	}
	nav.topnav ul.navigation li {
    		display: inline-block;
   		margin-left: 0.5em;
	}
	nav.topnav ul.navigation li a, nav.topnav ul.navigation li a:visited {
    		border-bottom: 5px solid #FFFFFF;
    		color: #3E914F;
    		line-height: 1em;
    		padding-bottom: 5px;
    		text-decoration: none;
	}
	nav.topnav ul.navigation li a:hover {
    		border-bottom: 5px solid #74B46F;
    		color: #1F4A28;
    		text-decoration: none;
	}
	
	nav.topnav ul.navigation li:first-child {
    		margin-left: 0 !!important;
	}
	'! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:25'!
allTags
^(allPages tagDictionaryKeys)! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 18:52'!
allTitles
^(allPages tagDictionaryKeys) do: [ :each| each asString ]! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 18:31'!
currentTOCPage
^currentTOCPage! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/11/2013 19:37'!
currentTOCPage: anObject
currentTOCPage:=anObject! !

!TikiWebMain methodsFor: 'constants' stamp: 'NateOrlow 7/10/2013 17:24'!
defaultSummary
^'Input optional summary here'! !

!TikiWebMain methodsFor: 'searching' stamp: 'NateOrlow 7/15/2013 15:12'!
findWithTag: aTag among: pagesDatabase
"you can just call this directly."
^ pagesDatabase findWithTag: aTag! !

!TikiWebMain methodsFor: 'initializing' stamp: 'NateOrlow 7/15/2013 16:25'!
initialize
super initialize.
self resetHomeOptions.

summaryInput:=self defaultSummary. "this is constant"
mainInput:='Test input'.

allPages := TikiPageDatabase new.
allPages initialize. "I don't see why this isn't being called 
automatically"
allSummaries:= TikiSummaryDatabase new.
allSummaries initialize.

self initializeSpanish.
currentCourse:=allPages allPagesCourse.

currentPage:= allPages getFirst.
currentTag:=currentPage tag.
currentTOCPage:= currentTag asString.
! !

!TikiWebMain methodsFor: 'initializing' stamp: 'NateOrlow 7/15/2013 16:19'!
initializeSpanish
"#tenerque Tienes que #infinitives usar #agreement estos ejemplos."
"THESE MUST STAY IN THE CURRENT ORDER FOR TAG DICTIONARY"

allPages add: (TikiPage newFrom:'#tenerque Tienes que #infinitives usar #agreement estos ejemplos.' tag: #main).
allSummaries add:(TikiSummary newTag: #main text: 'An example of a sentence').

allPages add: (TikiPage newFrom:'#nolink Tener que is an expression which means (have to). It is used by conjugating the verb #tener tener ' tag: #tenerque).
allSummaries add: (TikiSummary newTag: #tenerque text: 'Tener que means (have to)').

"#infinitives is missing to demonstrate creating a new page"
allPages add: (TikiPage newFrom:'#nolink Note that adjectives need to agree with the nouns they are modifying, so a masculine noun requires a masculine adjective or adverb.' tag:#agreement).
allSummaries add: (TikiSummary newTag: #agreement text:'The adjective/adverb must agree with the noun').

allPages add: (TikiPage newFrom:'#nolink Tener is the verb which means (to have) and is an irregular verb.' tag:#tener ).
allSummaries add: (TikiSummary newTag:#tener text: 'Tener means to have').

tempCourse:= TikiCourse newCourseName:'Temp course' tagList: (#(#tener #agreement) asOrderedCollection).! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:38'!
makeNewPage
	(summaryInput = self defaultSummary) ifTrue:[summaryInput=''].
	allSummaries add: (TikiSummary newTag: linkTag text: summaryInput).
	allPages add: (TikiPage newFrom: mainInput tag: linkTag).
	self navigateToTag: linkTag.! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 16:09'!
navigateToTag:aSymbol
 	currentPage:=(self findWithTag: aSymbol among: allPages). "change the current page, not the summary"
	currentTag:=aSymbol.
	expanded:=''.! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 15:12'!
nextPage
currentPage:= self findWithTag: (currentCourse tagAfter: (currentPage tag)) among: allPages! !

!TikiWebMain methodsFor: 'navigating' stamp: 'NateOrlow 7/15/2013 15:12'!
previousPage
currentPage:= self findWithTag: (currentCourse tagBefore: (currentPage tag)) among: allPages! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:09'!
processSummaryClick: aSymbol
self navigateToTag:aSymbol.! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:21'!
processTagClick: aSymbol
		(aSymbol = #nolink) ifTrue: [^' (nolink was clicked)']. "this means nolink tags will not be processed"
	((self allTags) includes: aSymbol) ifFalse:[
		makingnewpage:=true.
		editting:=true.
		linkTag:=aSymbol.
	] ifTrue:[
		makingnewpage:=false.
		expanded=aSymbol ifTrue:[
			currentPage:=allPages findWithTag: aSymbol.
			expanded:=''
			] ifFalse:	[
			expanded:=aSymbol.
			]
		]! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:34'!
renderContentOn: html 
	"html heading: 'Version 10'.
	html break."
	html form:[
		html div
		class:'mainbox';
		with:[
			self renderCourses:html.
			html div
			class:'editcontrols';
			with:[
				editting ifTrue:[self renderEditting: html.
				] ifFalse:[
					(currentPage orderedLinks) do:[
						:each | self renderPageLink:html for: each
					].
				].
				html break.
				self renderEditCancelButtons: html.
			].	
			html break.
			self renderTOC: html.
		].	
	].	
	html break.
	html anchor
		callback: [ self processSummaryClick: #temp ];
		with: 'Test pop-up window'.! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/13/2013 03:33'!
renderCourses: html
	html submitButton
		text:'Switch to temp course';
		callback: [ currentCourse:=tempCourse ].
	html submitButton
		text:'Switch to all pages';
		callback: [ currentCourse:=(allPages allPagesCourse)  ].
	"html text: (currentPage tag) asString."
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:36'!
renderEditCancelButtons: html
	html submitButton 
	callback: [self submitEdit];
	text: (editting ifTrue: ['Submit page'] ifFalse: [ 'Start editting' ]).
	editting ifTrue:[
		html cancelButton
		callback:[editting:=false];
		text: ('Cancel edit').
	]! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:14'!
renderEditting: html
	makingnewpage ifTrue:[self renderEdittingNewPage: html].
	html textInput
	on: #summaryInput of: self.
	html break.
	html textInput
	on: #mainInput of: self
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:15'!
renderEdittingNewPage: html
	html span
	class:'titletext';
	with:[ html text: 'Making new page: #',(linkTag asString)].
	html break.
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:49'!
renderHomeButton: html
	html submitButton
		callback: [ self navigateToTag: currentCourse firstTag. self resetHomeOptions];
		text: 'Home screen'.
! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 15:12'!
renderPageLink: html for: each
	| tempAllTags |
	tempAllTags := self allTags.
	html span
	class: ((tempAllTags includes: each) 
		ifFalse: [ (each asSymbol = #nolink) ifTrue:['nolink'] ifFalse:['newtag']]
		ifTrue: [ 'existingtag' ]);
	with: [ 
		html anchor
		callback: [ self processTagClick: each asSymbol ];
		with: (currentPage linkDictionary at: each ifAbsent: [ '(' , each asString , ')' ]).

		html text: ' '.
		each = expanded ifTrue: [ 
			html span
			id: 'summarytext';
			with: [ 
				html anchor
				callback: [ self processSummaryClick: each asSymbol ];
				with: ' (' , ((self findWithTag: each asSymbol among:allSummaries) text), ') ' 
			]."end span with"
		html text: ' ' 
		]"end expanded with" 
	]"end span with"! !

!TikiWebMain methodsFor: 'rendering' stamp: 'NateOrlow 7/15/2013 16:11'!
renderTOC: html
	html break.
	html submitButton
		text: 'Previous page';
		callback: [self previousPage].
	
	self renderHomeButton: html.

	html submitButton
		text: 'Next page';
		callback: [self nextPage].
	html break.
	html select
		size:5;
		list: (currentCourse tagList);
		"list: (self allTitles);" "tag names are the easiest to use" 
		"though this allows support for titles in case we want to do that later on."
		selected: currentTag asString;
		callback: [:pageChosen|self navigateToTag: (pageChosen asSymbol)].
	html break.
	html submitButton 
		text:'View selected page'.
		"this just refreshes the screen"
! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/10/2013 18:40'!
resetHomeOptions
	expanded:=''.
	editting:=false.
	makingnewpage:=false.! !

!TikiWebMain methodsFor: 'processing actions' stamp: 'NateOrlow 7/15/2013 16:33'!
submitEdit
editting ifFalse:[
	editting:=true.
	mainInput:=(self findWithTag: currentTag among:allPages) stringForEditting.
	summaryInput:=(self findWithTag: currentTag among:allSummaries) text.
] ifTrue:[
	editting:=false.
	(mainInput beginsWith: '#') ifFalse:[mainInput:= '#nolink ',mainInput]. 
	makingnewpage ifTrue:[self makeNewPage] ifFalse:[
	(self findWithTag: currentTag among:allSummaries) text: summaryInput
	]. currentPage makeLinkDictionaryFrom: mainInput.
	expanded=''.
]! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput
^summaryInput! !

!TikiWebMain methodsFor: 'accessing' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput: anInput
summaryInput:=anInput! !

TikiWeb subclass: #TikiWebPopupWindow
	instanceVariableNames: 'mainInput currentPage editting expanded tenerquePage tenerPage infinitivePage agreementPage mainPage pageDB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
canBeRoot
^true! !

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
initialize
	super initialize! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:05'!
buildPage: html 
	| id anchorId |
	html heading: 'Chapter 1 Seciont 2: Colors'.
	html break.
	html section
		id: html nextId;
		class: 'content';
		with: [ html text: 'test out'].
		
	html code
		id: #tempID;
		with: DateAndTime now.
		
	html break.

	html div
		id: (id := html nextId);
		script: (html jQuery new dialog
     			title: '';
	     		autoOpen: false);
     		with: [ self renderDialogOn: html].

	html  anchor
			id: (anchorId := html nextId);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #red) ]
						);
			onClick: ((html jQuery id: id) dialog
						open
						);
			onClick: ((html jQuery id: id) dialog
						position: [ 100,100 ]
						);
			with: 'car apple stopsign mars'.
	html break.
	html  anchor
			id: (anchorId := html nextId);
			onClick: ((html jQuery id: id) dialog
						open
						);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #blue) ]
						);
			with: 'sky ocean blueberry'.

	html jQuery 
! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 22:07'!
dialogContentFor: aSymbal
	^('You clicked on ',aSymbal asString,' objects')! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:56'!
findPageWithId: anID among: pagesCollection 
	"This should be replaced when ID checking improves"
	^(pagesCollection detect: [:eachpage| eachpage tag = anID] ifNone: mainPage).! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:51'!
initialize
	super initialize.
	editting:=false.
	mainInput:='Test input'.
	pageDB := TikiDataBaseServer getInstance connectToDB: ''.

! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput
^mainInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:12'!
processSummaryClick: aSymbol
	"(aSymbol=#nolink) ifFalse:["
		currentPage:=(self findWithTag: aSymbol among: pageDB).
	"]"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:12'!
processTagClick: aSymbol 
	"(aSymbol=#nolink) ifFalse:["
		expanded=aSymbol ifTrue:[currentPage:=(self findWithTag: aSymbol among: pageDB). expanded:=''] ifFalse:	[expanded:=aSymbol.]
	"]"
	"self inform: 'You clicked on ',( aSymbol asString)"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/6/2013 12:42'!
renderBox: aString on: html with: contentString
	html div id: aString; class: 'box'; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: contentString ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:03'!
renderContentOn: html 
	 | anchorId|
	html div
		id: 'main';
		class: 'tikipage';
		with: [ self buildPage: html].
! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 21:09'!
renderDialogOn: html
	html div id: (html nextId); class: 'box'; with: [
		html div class: 'header'.
		html div
			id: #boxcontent;
			class: 'content';
			with: 'Brief explanation, cross references, all forum posts about this, etc' ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/11/2013 22:08'!
style 
	^'body { 
		margin: 0;
		font: 11px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
		background: url(background.gif) repeat-x #fff;
	}

	img {
		border: 0px;
	}

div#main {
    min-height: 500px;
}

section.content {
    margin: 30px auto;
    width: 100%;
}
section.content {
    border-color: #74B46F;
    border-style: solid;
    padding: 0 1em;
    width: 42em;
}
section.content h1 {
    font-size: 1.8em;
}
section.content h1, section.content h2, section.content h3, section.content h4, section.content h5, section.content h6 {
    border-left: 10px solid #74B46F;
    padding-left: 10px;
}
section.content h1.title {
    border-left: 15px solid #74B46F;
    display: block;
    font-size: 1.9em;
    margin-bottom: 0.3em;
    padding-left: 15px;
}
section.content hr {
    background: -moz-linear-gradient(left center , #FFFFFF 0%, #74B46F 50%, #FFFFFF 100%) repeat scroll 0 0 transparent;
    border: 0 none;
    height: 1px;
}
section.content span.date {
    color: #999999;
    font-size: 0.8em;
}
section.content figure {
    text-align: center;
}
section.content figure img {
    max-width: 100%;
}


section.content p code, section.content li code, section.content h1 code, section.content h2 code, section.content h3 code, section.content h4 code, section.content h5 code, section.content h6 code, section.content h7 code {
    background: none repeat scroll 0 0 #F7F7F7;
    border: 1px solid #BBBBBB;
    border-radius: 0.3em 0.3em 0.3em 0.3em;
    color: #495D7C;
    display: inline;

    font-size: 0.9em;
    line-height: 1.5em;
    padding: 0.05em 0.3em;
    white-space: nowrap;
}

tikipage { 
	width: 1024;
	   margin: 30px auto;
   
	 }

#header {
	height: 110px;
	text-align: right;
	background: url(SUAllTestLibrary / #headerGif ) #7e9e50;
	color: #333;
	margin-bottom:25px;
}

#logo {
	float: left;
}

#menu {
	list-style-type: none;
	position: absolute;
	right: 0px;
	top: 95px;
	margin: 0px;
	padding: 0px;
	margin-top: -10px;
	padding-right: 5px;
}

#menu li {
	text-transform: lowercase;
	float: left;
}

#menu li a {
	display: block;
	width: 110px;
	padding-top: 9px;
	height: 16px;
	text-align: center;
	text-decoration: none;
	color: #fff;
	font-weight: bold;
	background: url(menu.gif) 110px 0px;
}

#menu a.active {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#menu a:hover {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#content {
	margin-left: 60px;
	margin-right: 60px;
}

#content h1 {
	font: 22px Georgia, serif;
	color: #7e9e50;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	text-transform: lowercase;
	font-style: italic;
	padding-bottom: 4px;
	border-bottom: 1px dotted #c5dea1;
	clear: left;
}

#content h2 {
	font: 18px Georgia, serif;
	color: #7e9e50;
	font-size: 15px;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	margin-top: 20px;
	text-transform: lowercase;
	font-style: italic;
}

#content h3 {
	font: 13px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
	margin: 0px;
	padding: 0px;
	margin-left: 10px;
	margin-top: 10px;
	font-weight: bold;
	text-transform: lowercase;
	color: #444444;
}

#content p, div.paragraph {
	font-size: 12px;
	line-height: 1.7;
	color: #444444;
	margin-left: 10px;
	margin-top: 10px;
}

/* demo box */
div.box {
	width: 120px;
	height: 120px;
	margin-right: 10px;
	margin-bottom: 10px;

}

div.box div.header {
	height: 23px;
	/*background: url(SUAllTestLibrary / #headerGif) repeat-x;*/
	background: #7e9e50;
}

div.box div.content {
	padding-top: 1em;
	text-align: center;
	/*background: url(SUAllTestLibrary / #demoGif);*/
	background: #f5f5f5;
}

div.smallBox {
	width: 100%;
	height: 100%;
	background: url(demo.gif) ;
}

div.smallBox div.header {
	height: 20px;
	background: url(demo-logo.gif) repeat-x;
}
div.smallBox div.content {
	padding-top: 1em;
	text-align: center;
}

/* source code */
div.source {
	margin: 5px;
	padding: 5px;
	border: 1px solid #dddddd;
	background: #f5f5f5;
	font: 12px Lucida Sans Typewriter, Courier, monospace;
}
a:link {color:black; text-decoration:none}
a:visited{color:black; text-decoration:none}
a:hover { color:gray; text-decoration:none} 
a:active { color:black; text-decoration:none}
'
! !

OrderedCollection subclass: #TikiDatabase
	instanceVariableNames: 'tagDictionary lastPageId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDatabase commentStamp: '<historical>' prior: 0!
A TikiDatabase is the parent of TikiPageDatabase and TikiSummaryDatabase 

Instance Variables
!

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:15'!
add: anObject
"public, use this to add pages to the database"
(lastPageId > 0) ifTrue: [super add: anObject afterIndex: lastPageId.] ifFalse: [super add: anObject].
self updateTagDictionaryWith: (anObject tag). 
self addMoreWith: anObject.
! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:15'!
addMoreWith: anObject
"does nothing if there isn't more to add"! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:53'!
findWithTag: aSymbol
"public"
( (tagDictionary keys) includes: aSymbol) ifTrue: [ ^ self at: (tagDictionary at: aSymbol)]  ifFalse: [^ self getFirst]! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:51'!
getFirst
self assert: (self size) > 0. 
^(self at: 1)
! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:10'!
initialize
	tagDictionary := Dictionary new.
	super initialize.	
	lastPageId:=0.! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:46'!
tagDictionaryAt: aSymbol
^ (tagDictionary at: aSymbol)! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:46'!
tagDictionaryKeys
^ (tagDictionary keys)! !

!TikiDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:59'!
updateTagDictionaryWith: aSymbol
"(This should be private?)"
lastPageId:=lastPageId+1.
tagDictionary at: aSymbol put: lastPageId! !

TikiDatabase subclass: #TikiPageDatabase
	instanceVariableNames: 'allPagesCourse'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageDatabase commentStamp: '<historical>' prior: 0!
A TikiPageDatabase is where pages are kept, with added messages for working with the pages.


Instance Variables
	lastPageId:		<Object>
	tagDictionary:		<Object>

lastPageId
	- xxxxx

tagDictionary
	- xxxxx
!

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:09'!
addMoreWith: anObject
allPagesCourse add: (anObject tag).
! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:11'!
allPagesCourse
^allPagesCourse! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:58'!
initialize
	super initialize.
	allPagesCourse := TikiCourse newCourseName: 'All pages' tagList: ((self tagDictionaryKeys) asOrderedCollection).! !

TikiDatabase subclass: #TikiSummaryDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSummaryDatabase commentStamp: '<historical>' prior: 0!
A TikiSummaryDatabase is a collection of TikiSummary objects, similar to TikiPageDatabase

Since TikiPageDatabase is already an ordered collection.

Instance Variables
!

Object subclass: #TikiAbstractDatabase
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiAbstractDatabase commentStamp: '<historical>' prior: 0!
TikiAbstractDatabase acts as an interface for all other components which store contents into or load contents from disk.

Using tempelate pattern to move real job to subclasses.!

!TikiAbstractDatabase class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:32'!
open: url
	^(self new connect: url)! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:14'!
connect: aUrl 
	url := aUrl
	! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:26'!
loadRawPageFor: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:29'!
loadRawSumFor: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:23'!
removeTag: tag 
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:15'!
savePage: aPage for: tag
	self saveRawPage: (aPage stringForEditting) for: tag! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:19'!
saveRawPage: aStrin  for: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:19'!
saveRawSum: aString for: tag
	self subclassResponsibility ! !

!TikiAbstractDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:17'!
saveSummary: summary for: tag
	self saveRawSum: (summary text) for: tag! !

TikiAbstractDatabase subclass: #TikiNativeFileDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 22:23'!
loadContentFor: tag with: ext
	| tmp output filename |
	filename := (url,'\',(tag asString),'.',ext).
	(StandardFileStream isAFileNamed: filename) ifFalse: [^nil].
	output 	:= WriteStream on: (String new: 10).
	tmp := StandardFileStream readOnlyFileNamed: filename.
	[tmp atEnd]
		whileFalse:
			[ output nextPut: tmp next ].
	^output contents ! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:56'!
loadRawPageFor: tag
	^self loadContentFor: tag with: 'page'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:57'!
loadRawSumFor: tag
	^self loadContentFor: tag with: 'page'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/14/2013 23:25'!
removeTag: tag ! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:56'!
saveContent: aString for: tag with: ext
	| tmp |
	tmp := StandardFileStream forceNewFileNamed: (url,'\',(tag asString),'.',ext).
	tmp nextPutAll: aString.
	tmp close! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:57'!
saveRawPage: aString  for: tag
	self saveContent: aString for: tag with: 'page'! !

!TikiNativeFileDatabase methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/15/2013 21:57'!
saveRawSum: aString for: tag
		self saveContent: aString for: tag with: 'sum'! !

Object subclass: #TikiCourse
	instanceVariableNames: 'courseName tagList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiCourse commentStamp: '<historical>' prior: 0!
A TikiCourse is a list of tags

Instance Variables
	courseName:		<Object>

courseName
	- xxxxx
!

!TikiCourse class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:15'!
newCourseName: aString tagList: anOC 
|tempCourse|
tempCourse:=TikiCourse new.
tempCourse courseName:aString tagList:anOC.
^tempCourse.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:57'!
add: aTag
tagList add: aTag! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/12/2013 19:20'!
courseName
^courseName! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/12/2013 19:20'!
courseName: aString
courseName:=aString.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:48'!
courseName: aString tagList: anOC 
courseName:=aString.
tagList:=anOC.! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:29'!
firstTag
^(tagList at: 1)! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:42'!
tagAfter:aTag
	|tempIndex|
	tempIndex:= tagList indexOf: aTag ifAbsent: 1.
	(tempIndex < tagList size) ifTrue: [ ^ tagList at: tempIndex+1 ].
	^ tagList at: tagList size! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 02:43'!
tagBefore:aTag
	|tempIndex|
	tempIndex:= tagList indexOf: aTag ifAbsent: 1.
	tempIndex > 1 ifTrue: [ ^ tagList at: tempIndex-1 ].
	^ tagList at: 1! !

!TikiCourse methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/13/2013 03:21'!
tagList
^tagList! !

Object subclass: #TikiDataBaseServer
	instanceVariableNames: 'dbPool'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDataBaseServer commentStamp: '<historical>' prior: 0!
The system may have many TikiWeb instances. Some of them are accessing the same database for web page contents. Image all cs528 students reading the course website.

Usually database systems can support several requests simutaneous, so the server doesn't have to keep multiple TikiPageDatabase instances.

This class, TikiDataBaseServer, keeps one TikiPageDatabase instance per database URL. Itself has a singleton instance per seaside server.!

!TikiDataBaseServer class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:41'!
getInstance
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiDataBaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:47'!
connectToDB: aURL
	dbPool keysDo: [ :each | each = aURL ifTrue: [ ^dbPool at: aURL ] ].
	dbPool at: aURL put: TikiPageDatabase new .
	^ dbPool at: aURL! !

!TikiDataBaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:42'!
initialize 
	dbPool := Dictionary new! !

Object subclass: #TikiPage
	instanceVariableNames: 'orderedLinks linkDictionary summary tag stringForEditting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPage commentStamp: '<historical>' prior: 0!
A TikiPage is an  indivisual page object, containing a tag and information, as well as a link dictionary.

Instance Variables
	linkDictionary:		<Object>
	orderedLinks:		<Object>
	summary:		<Object>
	tag:		<Object>

linkDictionary
	- xxxxx

orderedLinks
	- xxxxx

summary
	- xxxxx

tag
	- xxxxx
!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 12:46'!
newFrom:aString tag: aTag
|tempPage|
tempPage:=TikiPage new.
tempPage tag:aTag.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:32'!
newFrom:aString tag: aTag summary: aSummary
|tempPage|
tempPage:=TikiPage new.
tempPage tag:aTag summary:aSummary.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
initialize 
linkDictionary:=Dictionary new.
orderedLinks:=OrderedCollection new.
summary:=''.
stringForEditting:=''.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempTag tempText tempLength tempIndex|
stringForEditting:=aString.

rawLinkList:=aString findTokens:$#.
"linkDictionary:= Dictionary new."
orderedLinks removeAll.
(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ].

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempTag:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength. orderedLinks add:tempTag. linkDictionary at: (tempTag asSymbol) put: tempText].
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:29'!
orderedLinks
^orderedLinks! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:54'!
stringForEditting
^stringForEditting! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:42'!
summary
^summary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:29'!
tag
^tag! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 12:45'!
tag: aSymbol
tag:=aSymbol.
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:30'!
tag: aSymbol summary: aSummary
tag:=aSymbol.
summary:=aSummary.! !

Object subclass: #TikiPageAgingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageAgingStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool!

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:54'!
activate: page in: sortedCollection 
! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:19'!
insert: aPage to: sortedByAge 
	"Insert aPage into a collection, sortedByAge. Subclasses can implement their own sortedByAge classes and override this method"
	! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:53'!
retirePagesFrom: theSortedCollection
	! !

Object subclass: #TikiPagePreloadStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPagePreloadStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool as the strategy to decide which pages should be preloaded to accelerate load time.!

!TikiPagePreloadStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:14'!
computePageToBeLoad: aPage
	"given aPage, return an array with page ID's to be preloaded in itsuper "
	^#()! !

Object subclass: #TikiSerializable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSerializable commentStamp: '<historical>' prior: 0!
The pages and pop-up windows are rendered when they are needed by the web, or, they are opened by user clicks.

TikiSerialiable instances represent these objects. They can be edited by users and serialized into disk.
!

TikiSerializable subclass: #TikiPageFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

Object subclass: #TikiSummary
	instanceVariableNames: 'tag text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSummary commentStamp: '<historical>' prior: 0!
A TikiSummary contains the content for summary -- basically what is clicked on when a link is explored.

Instance Variables
!

!TikiSummary class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 14:17'!
newTag:aSymbol text:aString 
 |tempSummary|
tempSummary := TikiSummary new tag:aSymbol text: aString.
^tempSummary! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:49'!
tag
^tag! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:47'!
tag: aSymbol text: aString
tag:=aSymbol.
text:=aString.
! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 11:49'!
text
^text! !

!TikiSummary methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/15/2013 15:59'!
text: aString
text:=aString.! !

Object subclass: #TikiWebPagePool
	instanceVariableNames: 'pagePool sortedByAge preloadStrategy pageSema strategySema capacity agingStrategy'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebPagePool commentStamp: '<historical>' prior: 0!
Singleton per Seaside server. It maintains a pool for TikiWebPage instances, so that TikiWebPage not being viewed by user can be cached here. 

If a TikiWebPage instance ages (decided with ageStrategy), it'll be removed from pool.

Some TikiWebPage instances may be preloaded according to preloadStrategy in order to be rendered faster. Potential preloadStrategy include to load next page of current one.!

!TikiWebPagePool class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:07'!
getThePool
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:53'!
add: aPage withID: id
	"Add a page to pool. Remove old pages if pool size exceeds capacity
	This has to be called with pageSema held"
	| oldpages |
	pagePool at: id put: aPage.
	agingStrategy add: aPage withID: id.
	self pageCount > (self capacity ) ifTrue: [ 
				oldpages := agingStrategy retirePagesFrom: sortedByAge ]
			ifFalse: [ ^nil ].
	oldpages do: [ :each | pagePool removeKey: each ]
! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:23'!
ageStrategy: anAgeStrategy
! !

!TikiWebPagePool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity
	^capacity! !

!TikiWebPagePool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity: anInteger
	capacity := anInteger ! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:54'!
findPage: id
	| page |
	page := pagePool at: id 
		ifAbsent: [ ^nil ].
	agingStrategy activate: id in: sortedByAge.
	^page! !

!TikiWebPagePool methodsFor: 'initialize-release' stamp: 'PengLiu 7/9/2013 22:25'!
initialize 
	pagePool := Dictionary new! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:26'!
pageCount
	^pagePool size! !
TikiWebPopupWindow initialize!
TikiWebMain initialize!
